{$R-,Q-,S-,Q-}
uses Crt,SetPal;

var BiosTicks: longint absolute $0040:$006C;

{---------------- Stuff not specific to snowfall ----------------}
procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of Byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr;
    Pal3,Pal4:TPalette;
    Pal3L:TPaletteLinear absolute Pal3;
    Pal4L:TPaletteLinear absolute Pal4;

function LongMul(X, Y: Integer): Longint;
inline($5A/$58/$f7/$EA);

function LongDiv(X: Longint; Y: Integer): Integer;
inline($59/$58/$5A/$F7/$F9);

const color:byte=1;
procedure FEllipse(X,Y,AX,AY:Integer);
var I,J:Integer;
    s:longint;
begin
  for I:=Y-AY to Y+AY do begin
    for J := X-AX to X+AX do begin
        if Color<>0 then
          Scr3^[I,J] := Scr4^[
            100+(I-Y)*99 div AY,
            160+(J-X)*159 div AX]
        else Scr3^[I,J] := 0;
    end;
  end;
end;

procedure MOVS(var SOURCE, DEst); assembler;
asm
  push ds
  push es
  mov  es, word ptr [dest+2]
  mov  ds, word ptr [source+2]
  xor  si,si
  xor  di,di
  mov  cx, $4000
  cld
  db $66     { \\\           }
  rep  movsw { /// rep movsd }
  pop  es
  pop  ds
end;

{---------------------------MAIN PROGRAM-------------------------}

var
  I : Longint;                       { to add velocity to flakes }
  J: Word;
  X,Y,V,R,VX,VY,VR: Integer;
  F:file;
label M1,M2,MExit;
const XSize=48;
      YSize=30;
begin
  Randomize;

  vidMode($13);                       { 320x200x256 graphics mode }

  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  Assign(F,'monster.PAL'); ReSet(F,1);
  BlockRead(F,PAL4,SizeOf(TPaletteLinear));
  Close(F);
  Palette:=Pal4; SetPalette;
  FillChar(Scr3^,65535,#0);

  X := 160; Y:=100;
  R:=15; VX:=0; VY:=0;
  repeat

{    while (Port[$3DA] and $08) = $00 do;  { start and end        }
{    while (Port[$3DA] and $08) = $08 do;  { wait for vRetrace to }
    MOVS(Scr3^, Scr);

    Color:=0;
    FEllipse(X,Y,XSize+R,YSize-R);

    Inc(I);

    Color:=9;
    X:=160{10+XSize+Abs(I mod((300-XSize*2)*2) - (300-XSize*2))};
    Y:=160-(I mod 200)*(199- I mod 200) div 80;
    R:=Round((199-I mod 200)*Cos(I*PI/10)/20);
    FEllipse(X,Y,XSize+R,YSize-R);

    if KeyPressed then case ReadKey of
      #27: goto MExit;
    end;
  until False;
  MExit:

  vidMode($03);                       { return to 80x25 textmode }
end.

